﻿/*
 * LCD_2x16.c
 *
 * Created: 9/11/2015 1:13:01 am
 *  Author: Dimitrios Porlidas
 */  

#include "LCD_2x16.h"

unsigned char out;
unsigned char lg1;
unsigned char logo[] = {'H','u','m',':',' ',' ',' ',' ','%',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','D','H','T','1','1',' ','L','M','3','5',' ','D','S','1','8','B','2','0',' ',' ',
						'T','e','m',':',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',223,'C',' ',' ',' ','w','w','w','.','p','o','r','l','i','d','a','s','.','g','r',' ',' ',' ',' ',' ',};

void WrIn (unsigned char tmp)								// Write Instruction routine
{
	out = tmp & 0b11110000;									// Upper
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);
	_delay_us (100);
	lcdport = out;
	_delay_us (100);
	out = tmp << 4;											// Lower
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);
	_delay_us (100);
	lcdport = out;
	_delay_us (50);
}

void WrDa (unsigned char tmp)								// Write Data routine
{
	out = tmp & 0b11110000;									// Upper
	lcdport = (out | Da);
	_delay_us (100);
	lcdport = (out | En | Da);
	_delay_us (100);
	lcdport = (out | Da);
	_delay_us (100);
	out = tmp << 4;											// Lower
	lcdport = (out | Da);
	_delay_us (100);
	lcdport = (out | En | Da);
	_delay_us (100);
	lcdport = (out | Da);
	_delay_us (50);
}

void SeCu (unsigned char addr)								// Send cursor to a specific address (0-39, 64-103) or a specific assignment (L1R1-L4R20)
{
	WrIn (0b10000000 | addr);
}

void SeCG (unsigned char addr)								// Set CGRAM address
{
	WrIn (0b01000000 | addr);
}

void TypeLogo (unsigned char logo2[])						// Logo routine
{
	for (lg1 = 0; lg1 < 80; lg1++)							// Send logo
	WrDa (logo2[lg1]);
}

void TypeMainLogo (void)									// Main Logo routine
{
	for (lg1 = 0; lg1 < 80; lg1++)							// Send logo
	WrDa (logo[lg1]);
}

void InitLCD (void)											// Start up, initialization rutine
{
	lcdport = 0;
	out = 0b00110000;
	_delay_ms (20);											// Power on delay 20ms
	
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);									// Init
	_delay_us (100);
	lcdport = out;
	_delay_ms (5);
	
	lcdport = (out | En);									// Init
	_delay_us (100);
	lcdport = out;
	_delay_us (200);

	lcdport = (out | En);									// Init
	_delay_us (100);
	lcdport = out;
	_delay_ms (5);

	out = 0b00100000;										// 0, 0, 1, 4 bit interface/0, x, x, x, x
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);
	_delay_us (100);
	lcdport = out;
	_delay_us (50);

	WrIn (0b00101100);										// 0, 0, 1, 4 bit/0, 2 lines/1, 5x10/1(LCD), x, x

	WrIn (0b00001100);										// 0, 0, 0, 0, 1, Display on/1, cursor off/0, blinking off/0 (LCD)

	WrIn (0b00000110);										// 0, 0, 0, 0, 0, 1, Cursor increase/1, display not shift/0 (LCD)

	WrIn (CDRS);											// Clear display, reset cursor (LCD)
	_delay_ms (2);
	
//	TypeLogo (logo);
}