/*
 * Temp.c
 *
 * Created: 9/11/2015 1:10:59 am
 * Author : Dimitrios Porlidas
 */ 

//#include <avr/io.h>
//#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include "LCD_2x16.h"

unsigned char lm35;
unsigned char output[3];									// case 10 bit ***********************
unsigned char i1;
unsigned char decval[4];
unsigned char decval1[4];									// case 10 bit ***********************
unsigned char dht;
uint8_t dhtreg[5];
unsigned char bti;
unsigned char rgi;
uint8_t temprh[4];
uint8_t humidh[4];
unsigned char i3;


void InitADC (void)											// case 8 bit ************************
{
	ADCSRA = ((1 << ADEN) | (7 << ADPS0));					// ADC Enable, single conversion, 62.5kHz sample
	ADMUX = ((3 << REFS0) | (1 << ADLAR));					// 2.54V, left adjust result, PA0 (REFS0:1 = 0->AREF, 1->AVCC, 3->IntRef 2.54V)
}

void GetADC (void)
{
	ADCSRA |= (1 << ADSC);									// Start conversion
	while (!(ADCSRA & (1 << ADIF)));						// Wait for conversion to complete
	ADCSRA |= (1 << ADIF);									// Reset complete flag
	lm35 = ADCH;											// Write data to register
}

//	****case 10 bit start
void InitADC10 (void)										
{
	ADCSRA = ((1 << ADEN) | (7 << ADPS0));					// ADC Enable, single conversion, 62.5kHz sample
	ADMUX = (3 << REFS0);									// 2.54V, right adjust result, PA0 (REFS0:1 = 0->AREF, 1->AVCC, 3->IntRef 2.54V)
}

void GetADC10 (void)
{
	ADCSRA |= (1 << ADSC);									// Start conversion
	while (!(ADCSRA & (1 << ADIF)));						// Wait for conversion to complete
	ADCSRA |= (1 << ADIF);									// Reset complete flag
	lm35 = ADCL;											// Write data to register
}

void CalcOutputADC (unsigned int AdcOut)
{
	output[0] = 0;											// Reset register
	output[1] = '.';
	output[2] = 0;
	
	while (AdcOut > 3)										// Count decades
	{
		AdcOut = (AdcOut - 4);
		output[0]++;
	}
	if (AdcOut == 0)										// Calculate deciles
	output[2] = 0;
	else if (AdcOut == 1)
	output[2] = 3;
	else if (AdcOut == 2)
	output[2] = 5;
	else if (AdcOut == 3)
	output[2] = 8;
	output[2] = (output[2] | 0b00110000);					// Convert to ASCII monads
}
//	****case 10 bit end

int main(void)
{
	DDRA = 0b11111110;                                      // Port A: 0 input (DAC), 1-7 outputs (LCD)
	
	InitLCD ();
	
	TypeMainLogo ();
	
	SeCG(0);												// Write data to CGRAM routine
	_delay_ms(5);
	for (i1 = 0; i1 <10; i1++)								// Blanc character for ASCII 'NUL' (0x00) in LCD
	WrDa(0);
	
//	InitADC ();
	
    while (1) 
    {
		DDRC = (DDRC | 0b00000001);							// Init DHT Port
		PORTC = 1<<PORTC0;									//
		_delay_ms(100);

//	****case 8 bit start		
		InitADC ();
		GetADC ();											// Get ADC conversion
		itoa (lm35, decval, 10);							// Transform binary 0-255 to decimal ASCII string
		if ((lm35 >= 0) && (lm35 < 10))								// Restore zeros in one digit decimal number
		decval[2] = decval[0], decval[1] = '0', decval[0] = '0';
		else if ((lm35 >= 10) && (lm35 < 100))						// Restore zeros in two digits decimal number
		decval[2] = decval[1], decval[1] = decval[0], decval[0] = '0';
		
		SeCu (L2R9);
		_delay_ms (5);										// Send cursor to a specific address 0-80 (LCD)
		for (i1 = 1; i1 < 3; i1++)							// Send [Output] value to LCD
		WrDa (decval[i1]);
//	****case 8 bit end

//	****case 10 bit start		
		InitADC10 ();
		GetADC10 ();
		CalcOutputADC (lm35);								// Transform binary 0-255 to ASCII 00-50 (case 10bit)******************
		itoa (output[0], decval1, 10);						// Transform binary 0-255 to decimal ASCII string
		if ((output[0] >= 0) && (output[0] < 10))								// Restore zeros in one digit decimal number
		decval1[2] = decval1[0], decval1[1] = '0', decval1[0] = '0';
		else if ((output[0] >= 10) && (output[0] < 100))						// Restore zeros in two digits decimal number
		decval1[2] = decval1[1], decval1[1] = decval1[0], decval1[0] = '0';		
		SeCu (L2R12);
		_delay_ms (5);										// Send cursor to a specific address 0-80 (LCD)
		for (i1 = 1; i1 < 3; i1++)							// Send [Output] value to LCD
		WrDa (decval1[i1]);
		for (i1 = 1; i1 < 3; i1++)							// Send [Output] value to LCD
		WrDa (output[i1]);
//	****case 10 bit end
		
//		DDRC = (DDRC | 0b00000001);							// Init DHT Port
//		PORTC = 1<<PORTC0;									// 
//		_delay_ms(100);
											
		PORTC = 0<<PORTC0;									// Start communication with DHT, MCU Request (PORTC = 0;)
		_delay_ms(18);												
		PORTC = 1<<PORTC0;									// MCU Request (PORTC = 1;)
		_delay_us(40);													
		DDRC = (DDRC & 0b11111110);							// Port turns to input (DDRC = 0;)												
		PORTC = 1<<PORTC0;									// Enable pull up (PORTC = 1;)
		_delay_us(20);
		while (!(bit_is_set(PINC,0)));						// DHT Response PC0 = 0
		_delay_us(100);										// DHT Response PC0 = 1
		for (rgi = 0; rgi < 5; rgi++)						// Start reading DHT packet
		{
			for (bti = 0; bti < 8; bti++)					// Start reading byte
			{
			while (!(bit_is_set(PINC,0)));					// PC0 = 0
			_delay_us(40);
			if (bit_is_set(PINC,0))							// Read 1
			{
				dht = 1;
				while (bit_is_set(PINC,0));					// PC0 = 0
			}
			else											// Read 0
			dht = 0;
			dhtreg[rgi] = dhtreg[rgi]<<1;					// Shift register
			dhtreg[rgi] = (dhtreg[rgi] | dht);				// Load value
			}
		}

		itoa (dhtreg[0], humidh, 10);						// Humidity, Transform binary 0-255 to decimal ASCII string
/*		if ((dhtreg[0] >= 0) && (dhtreg[0] < 10))								// Restore zeros in one digit decimal number
		humidh[2] = humidh[0], humidh[1] = '0', humidh[0] = '0';
		else if ((dhtreg[0] >= 10) && (dhtreg[0] < 100))						// Restore zeros in two digits decimal number
		humidh[2] = humidh[1], humidh[1] = humidh[0], humidh[0] = '0';
*/		SeCu (L1R6);
		_delay_ms (5);										// Send cursor to a specific address 0-80 (LCD)
		for (i1 = 0; i1 < 3; i1++)							// Send [Output] value to LCD
		WrDa (humidh[i1]);
		
		itoa (dhtreg[2], temprh, 10);						// Temperature, Transform binary 0-255 to decimal ASCII string
/*		if ((dhtreg[2] >= 0) && (dhtreg[2] < 10))								// Restore zeros in one digit decimal number
		temprh[2] = temprh[0], temprh[1] = '0', temprh[0] = '0';
		else if ((dhtreg[2] >= 10) && (dhtreg[2] < 100))						// Restore zeros in two digits decimal number
		temprh[2] = temprh[1], temprh[1] = temprh[0], temprh[0] = '0';
*/		SeCu (L2R6);
		_delay_ms (5);										// Send cursor to a specific address 0-80 (LCD)
//		scanf("%d",temprh);
		for (i1 = 0; i1 < 3; i1++)							// Send [Output] value to LCD
		WrDa (temprh[i1]);
//		WrDa('A');
		
//		TypeLogo(xxx);
	}
}



